/*
ID: espr1t
TASK: Incinerator
KEYWORDS: Testgen
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <vector>
#include <string>

using namespace std;

struct Crcl {
    double x, y, r;
    Crcl(double x_ = 0.0, double y_ = 0.0, double r_ = 0.0) :
        x(x_), y(y_), r(r_) {}
};

struct Test {
    vector <Crcl> circles;
    Test(const vector <Crcl>& circles_) : circles(circles_) {}
};

vector <Test> tests;

void sampleInput() {
    vector <Crcl> circles = {
        Crcl(42.1337, 13.666, 191.17),
        Crcl(543.210, 765.432, 55.555),
        Crcl(987.987, 666.666, 321.321),
        Crcl(0, 1000, 100),
        Crcl(666.666, 66.66, 16.6),
        Crcl(133.331, 666.666666666, 123.321),
        Crcl(888.8, 88.8, 8.8)
    };
    tests.push_back(Test(circles));
}

void testTwo1() {
    vector <Crcl> circles = {
        Crcl(0, 0, 666),
        Crcl(1000, 1000, 666)
    };
    tests.push_back(Test(circles));
}

void testTwo2() {
    vector <Crcl> circles = {
        Crcl(0, 0, 666),
        Crcl(550, 700, 5)
    };
    tests.push_back(Test(circles));
}

void testTwo3() {
    vector <Crcl> circles = {
        Crcl(0, 0, 666),
        Crcl(550, 800, 5)
    };
    tests.push_back(Test(circles));
}

void testTwo4() {
    vector <Crcl> circles = {
        Crcl(123, 497, 42),
        Crcl(808, 505, 17)
    };
    tests.push_back(Test(circles));
}

void testTwo5() {
    vector <Crcl> circles = {
        Crcl(837, 987, 17),
        Crcl(959, 864, 13)
    };
    tests.push_back(Test(circles));
}

void testTwo6() {
    vector <Crcl> circles = {
        Crcl(500, 0, 50),
        Crcl(500, 1000, 50)
    };
    tests.push_back(Test(circles));
}

void handTest1() {
    vector <Crcl> circles = {
        Crcl(0.000, 0.000, 13.000),
        Crcl(0.000, 1000.000, 42.000),
        Crcl(1000.000, 0.000, 17.000),
        Crcl(1000.000, 1000.000, 55.000)
    };
    tests.push_back(Test(circles));
}

void handTest2() {
    vector <Crcl> circles = {
        Crcl(0.000, 0.000, 10.000),
        Crcl(0.000, 1000.000, 10.000),
        Crcl(1000.000, 0.000, 10.000),
        Crcl(1000.000, 1000.000, 10.000),
        Crcl(0.000, 500.000, 10.000),
        Crcl(1000.000, 500.000, 10.000),
        Crcl(500.000, 0.000, 10.000),
        Crcl(500.000, 1000.000, 10.000),
        Crcl(338.000, 282.000, 10.000),
        Crcl(267.000, 353.000, 10.000),
        Crcl(338.000, 744.000, 10.000),
        Crcl(267.000, 673.000, 10.000),
        Crcl(658.000, 282.000, 10.000),
        Crcl(729.000, 353.000, 10.000),
        Crcl(658.000, 744.000, 10.000),
        Crcl(729.000, 673.000, 10.000)
    };
    tests.push_back(Test(circles));
}

void handTest3() {
    vector <Crcl> circles = {
        Crcl(100.000, 100.000, 50.000),
        Crcl(300.000, 100.000, 50.000),
        Crcl(500.000, 100.000, 50.000),
        Crcl(700.000, 100.000, 50.000),
        Crcl(900.000, 100.000, 50.000),
        Crcl(100.000, 300.000, 50.000),
        Crcl(100.000, 500.000, 50.000),
        Crcl(100.000, 700.000, 50.000),
        Crcl(100.000, 900.000, 50.000),
        Crcl(300.000, 900.000, 50.000),
        Crcl(500.000, 900.000, 50.000),
        Crcl(700.000, 900.000, 50.000),
        Crcl(900.000, 900.000, 50.000),
        Crcl(900.000, 700.000, 50.000),
        Crcl(900.000, 500.000, 50.000),
        Crcl(900.000, 300.000, 50.000),
        Crcl(499.999, 499.999, 50.000)
    };
    tests.push_back(Test(circles));
}

void handTest4() {
    vector <Crcl> circles = {
        Crcl(42, 17, 202),
        Crcl(404, 917, 101),
        Crcl(783, 700, 21),
        Crcl(707, 287, 297)
    };
    tests.push_back(Test(circles));
}

void handTest5() {
    vector <Crcl> circles = {
        Crcl(633.788, 796.014, 158.355),
        Crcl(728.094, 234.534, 121.365),
        Crcl(931.670, 682.141, 123.185),
        Crcl(247.332, 194.325, 79.514),
        Crcl(106.492, 728.503, 63.725),
        Crcl(6.457, 456.982, 170.380),
        Crcl(371.183, 804.682, 11.106)
    };
    tests.push_back(Test(circles));
}

void handTest6() {
    vector <Crcl> circles = {
        Crcl(912.998, 755.554, 177.207),
        Crcl(96.038, 947.233, 36.788),
        Crcl(930.238, 279.785, 121.149),
        Crcl(658.469, 193.388, 57.286),
        Crcl(274.005, 605.117, 17.770),
        Crcl(249.663, 730.019, 99.764),
        Crcl(319.577, 357.653, 149.562),
        Crcl(51.181, 469.232, 1.089),
        Crcl(11.025, 163.780, 138.568),
        Crcl(429.060, 51.024, 134.106),
        Crcl(674.280, 969.851, 68.022),
        Crcl(823.337, 146.993, 47.916),
        Crcl(548.555, 868.239, 32.697)
    };
    tests.push_back(Test(circles));
}

void randomTest50() {
    vector <Crcl> circles = {
        Crcl(827.471, 880.162, 133.779),
        Crcl(14.129, 746.768, 11.522),
        Crcl(618.708, 230.709, 120.985),
        Crcl(476.184, 795.253, 180.029),
        Crcl(809.486, 586.775, 53.259),
        Crcl(159.701, 959.950, 1.206),
        Crcl(43.542, 117.509, 191.179),
        Crcl(217.328, 677.183, 43.290),
        Crcl(520.811, 548.965, 21.854),
        Crcl(487.601, 24.335, 70.408),
        Crcl(304.607, 470.169, 133.972),
        Crcl(71.408, 788.348, 6.499),
        Crcl(580.637, 361.403, 10.191),
        Crcl(431.440, 576.748, 14.466),
        Crcl(24.895, 642.461, 54.393),
        Crcl(56.299, 875.510, 44.575),
        Crcl(9.497, 318.453, 1.007),
        Crcl(739.488, 666.799, 32.116),
        Crcl(662.694, 724.513, 3.190),
        Crcl(120.741, 400.208, 48.873),
        Crcl(926.914, 26.040, 187.111),
        Crcl(339.471, 209.771, 29.704),
        Crcl(276.891, 272.209, 41.875),
        Crcl(283.293, 638.333, 32.190),
        Crcl(992.381, 759.456, 1.180),
        Crcl(900.847, 499.977, 52.696),
        Crcl(923.426, 332.563, 37.619),
        Crcl(245.573, 946.253, 16.100),
        Crcl(990.897, 919.925, 1.864),
        Crcl(272.343, 34.973, 17.377),
        Crcl(137.418, 685.423, 5.939),
        Crcl(165.462, 847.907, 23.410),
        Crcl(977.630, 405.094, 49.367),
        Crcl(865.129, 342.004, 4.069),
        Crcl(434.287, 187.919, 48.236),
        Crcl(660.135, 67.409, 3.956),
        Crcl(698.627, 502.555, 71.830),
        Crcl(58.002, 747.495, 14.036),
        Crcl(606.568, 45.324, 13.614),
        Crcl(336.600, 296.785, 2.498),
        Crcl(993.813, 636.987, 73.595),
        Crcl(90.582, 985.778, 14.513),
        Crcl(585.609, 594.304, 43.772),
        Crcl(269.735, 849.649, 4.456),
        Crcl(992.490, 299.628, 16.720),
        Crcl(659.948, 985.759, 24.049),
        Crcl(526.141, 415.145, 41.104),
        Crcl(81.724, 488.322, 14.412),
        Crcl(223.153, 825.231, 19.842),
        Crcl(469.335, 338.399, 50.129)
    };
    tests.push_back(Test(circles));
}

void randomTest75() {
    vector <Crcl> circles = {
        Crcl(16.349, 992.045, 20.393),
        Crcl(173.644, 492.135, 35.176),
        Crcl(481.947, 73.694, 160.659),
        Crcl(759.713, 334.637, 12.058),
        Crcl(519.929, 602.425, 53.957),
        Crcl(318.816, 747.882, 77.984),
        Crcl(839.171, 639.041, 18.504),
        Crcl(203.531, 255.803, 86.799),
        Crcl(776.353, 129.048, 63.292),
        Crcl(28.899, 464.718, 69.212),
        Crcl(961.537, 842.869, 176.414),
        Crcl(439.919, 645.611, 15.803),
        Crcl(777.418, 964.949, 41.747),
        Crcl(415.404, 413.605, 123.790),
        Crcl(998.805, 290.066, 152.179),
        Crcl(151.216, 695.935, 65.673),
        Crcl(25.829, 824.166, 83.037),
        Crcl(891.400, 519.682, 36.490),
        Crcl(126.891, 67.272, 3.037),
        Crcl(312.393, 562.586, 19.205),
        Crcl(618.351, 783.547, 48.681),
        Crcl(710.248, 380.540, 51.242),
        Crcl(346.642, 973.418, 63.742),
        Crcl(550.182, 484.093, 25.565),
        Crcl(20.483, 80.503, 49.198),
        Crcl(661.265, 482.903, 40.784),
        Crcl(472.404, 817.269, 49.963),
        Crcl(564.731, 870.971, 47.476),
        Crcl(847.107, 567.790, 17.166),
        Crcl(266.093, 552.636, 1.013),
        Crcl(541.317, 270.472, 14.330),
        Crcl(696.735, 221.075, 3.169),
        Crcl(151.996, 552.999, 24.182),
        Crcl(228.057, 407.640, 15.045),
        Crcl(635.243, 632.716, 19.138),
        Crcl(76.217, 178.789, 3.563),
        Crcl(505.886, 718.260, 31.223),
        Crcl(194.839, 439.265, 12.493),
        Crcl(797.865, 475.854, 23.037),
        Crcl(91.019, 951.421, 22.500),
        Crcl(89.360, 404.712, 15.896),
        Crcl(237.765, 121.760, 4.444),
        Crcl(28.147, 326.082, 43.027),
        Crcl(724.479, 36.397, 23.098),
        Crcl(61.695, 254.650, 34.830),
        Crcl(427.331, 908.802, 24.332),
        Crcl(189.548, 371.463, 13.347),
        Crcl(228.205, 928.817, 52.455),
        Crcl(595.504, 978.383, 48.432),
        Crcl(719.674, 576.910, 30.510),
        Crcl(451.593, 581.265, 7.950),
        Crcl(717.925, 801.665, 3.792),
        Crcl(787.117, 670.153, 40.473),
        Crcl(77.349, 733.016, 13.230),
        Crcl(982.408, 47.213, 32.247),
        Crcl(994.821, 585.550, 54.388),
        Crcl(566.662, 257.181, 1.932),
        Crcl(360.974, 870.039, 29.785),
        Crcl(129.831, 175.745, 12.008),
        Crcl(513.144, 960.274, 28.219),
        Crcl(763.647, 750.931, 14.511),
        Crcl(825.076, 301.803, 13.551),
        Crcl(271.170, 27.556, 24.881),
        Crcl(590.484, 588.973, 14.148),
        Crcl(476.141, 267.424, 33.073),
        Crcl(783.335, 342.600, 5.057),
        Crcl(638.551, 902.539, 1.571),
        Crcl(864.530, 193.088, 5.606),
        Crcl(779.193, 413.106, 23.487),
        Crcl(191.161, 14.447, 50.746),
        Crcl(882.881, 36.829, 14.901),
        Crcl(820.138, 3.745, 49.043),
        Crcl(547.420, 374.357, 7.971),
        Crcl(71.827, 645.536, 27.326),
        Crcl(139.138, 121.429, 5.623)
    };
    tests.push_back(Test(circles));
}

void randomTest100v1() {
    vector <Crcl> circles = {
        Crcl(185.681, 292.263, 187.860),
        Crcl(717.228, 387.563, 245.645),
        Crcl(556.826, 938.704, 11.566),
        Crcl(138.542, 576.068, 78.119),
        Crcl(255.153, 876.241, 108.860),
        Crcl(834.977, 146.230, 18.681),
        Crcl(987.336, 241.153, 40.391),
        Crcl(7.404, 835.297, 71.306),
        Crcl(559.227, 103.959, 37.583),
        Crcl(230.966, 647.758, 33.985),
        Crcl(881.966, 884.148, 264.430),
        Crcl(435.083, 629.991, 48.933),
        Crcl(441.546, 525.383, 55.201),
        Crcl(550.416, 753.429, 35.845),
        Crcl(919.638, 26.299, 49.602),
        Crcl(769.970, 75.022, 10.000),
        Crcl(554.726, 645.679, 10.000),
        Crcl(389.676, 428.038, 10.000),
        Crcl(502.037, 6.811, 27.399),
        Crcl(25.989, 439.338, 10.000),
        Crcl(371.578, 37.037, 10.000),
        Crcl(496.726, 185.598, 46.811),
        Crcl(520.573, 590.945, 10.000),
        Crcl(954.407, 538.501, 25.611),
        Crcl(500.389, 874.540, 30.562),
        Crcl(470.604, 698.141, 10.000),
        Crcl(279.761, 665.948, 12.446),
        Crcl(498.128, 793.018, 19.763),
        Crcl(89.419, 847.452, 10.000),
        Crcl(211.625, 38.689, 10.000),
        Crcl(479.965, 986.286, 62.778),
        Crcl(68.314, 937.293, 36.051),
        Crcl(346.738, 667.255, 22.230),
        Crcl(701.680, 43.446, 24.282),
        Crcl(422.956, 236.067, 14.174),
        Crcl(51.483, 127.975, 11.149),
        Crcl(136.961, 5.519, 28.328),
        Crcl(183.259, 985.111, 16.593),
        Crcl(943.332, 146.201, 10.000),
        Crcl(149.626, 770.176, 21.974),
        Crcl(248.533, 8.864, 31.901),
        Crcl(898.313, 116.432, 10.000),
        Crcl(133.326, 704.402, 20.617),
        Crcl(620.812, 17.995, 10.000),
        Crcl(30.328, 684.704, 35.206),
        Crcl(445.065, 720.531, 15.747),
        Crcl(416.687, 412.318, 20.703),
        Crcl(992.577, 475.935, 31.583),
        Crcl(822.150, 24.849, 24.675),
        Crcl(414.932, 113.568, 10.000),
        Crcl(38.288, 599.043, 10.000),
        Crcl(593.647, 950.213, 20.471),
        Crcl(31.798, 514.357, 38.417),
        Crcl(316.281, 484.721, 17.295),
        Crcl(886.311, 84.091, 10.000),
        Crcl(453.237, 1.684, 21.656),
        Crcl(207.211, 82.892, 10.000),
        Crcl(618.525, 81.350, 19.301),
        Crcl(401.430, 714.599, 13.922),
        Crcl(81.859, 720.240, 24.291),
        Crcl(295.830, 572.803, 29.331),
        Crcl(509.349, 917.525, 11.842),
        Crcl(227.521, 500.205, 10.000),
        Crcl(559.010, 606.315, 10.000),
        Crcl(410.247, 875.843, 30.445),
        Crcl(348.258, 462.608, 12.415),
        Crcl(265.544, 704.182, 20.597),
        Crcl(435.925, 920.401, 10.000),
        Crcl(561.363, 893.639, 10.000),
        Crcl(418.531, 157.817, 15.460),
        Crcl(246.396, 65.940, 10.000),
        Crcl(544.264, 828.997, 15.614),
        Crcl(21.298, 968.273, 18.419),
        Crcl(389.655, 753.239, 22.514),
        Crcl(816.594, 95.810, 10.000),
        Crcl(8.654, 46.191, 32.516),
        Crcl(175.028, 490.596, 10.000),
        Crcl(340.081, 972.716, 13.174),
        Crcl(398.716, 137.684, 10.000),
        Crcl(632.289, 767.974, 10.000),
        Crcl(478.783, 585.872, 12.712),
        Crcl(571.480, 671.171, 10.000),
        Crcl(969.867, 613.724, 14.694),
        Crcl(300.286, 82.785, 10.000),
        Crcl(967.744, 301.387, 17.150),
        Crcl(995.777, 320.891, 10.000),
        Crcl(980.404, 132.052, 26.339),
        Crcl(79.508, 38.105, 32.196),
        Crcl(274.827, 515.345, 21.125),
        Crcl(2.069, 177.369, 12.691),
        Crcl(746.416, 8.438, 28.074),
        Crcl(592.405, 820.076, 10.000),
        Crcl(16.073, 460.810, 11.111),
        Crcl(394.350, 816.913, 23.417),
        Crcl(409.847, 300.108, 23.620),
        Crcl(269.538, 484.285, 10.000),
        Crcl(784.806, 108.509, 21.272),
        Crcl(43.330, 16.083, 10.000),
        Crcl(352.183, 119.227, 12.603),
        Crcl(474.363, 82.843, 21.116)
    };
    tests.push_back(Test(circles));
}

void randomTest100v2() {
    vector <Crcl> circles = {
        Crcl(317.596, 578.698, 10.000),
        Crcl(865.772, 417.169, 10.000),
        Crcl(400.026, 536.159, 26.101),
        Crcl(128.221, 472.096, 20.104),
        Crcl(383.041, 702.150, 18.725),
        Crcl(56.139, 405.503, 10.000),
        Crcl(720.097, 846.004, 10.000),
        Crcl(577.459, 443.542, 49.789),
        Crcl(108.157, 345.410, 15.706),
        Crcl(747.368, 82.946, 10.000),
        Crcl(706.473, 904.830, 10.000),
        Crcl(163.778, 185.082, 12.498),
        Crcl(424.379, 207.816, 33.448),
        Crcl(188.985, 116.775, 10.000),
        Crcl(242.359, 552.938, 38.849),
        Crcl(827.519, 550.343, 18.489),
        Crcl(702.655, 788.492, 35.236),
        Crcl(58.715, 773.983, 36.032),
        Crcl(408.729, 423.174, 34.984),
        Crcl(207.434, 360.102, 33.277),
        Crcl(699.649, 115.499, 10.000),
        Crcl(323.418, 739.671, 13.546),
        Crcl(211.310, 462.684, 14.417),
        Crcl(347.745, 827.559, 20.094),
        Crcl(945.219, 342.709, 10.000),
        Crcl(543.723, 0.069, 24.195),
        Crcl(316.120, 240.447, 10.000),
        Crcl(985.538, 953.119, 38.805),
        Crcl(361.216, 16.122, 10.721),
        Crcl(581.088, 158.734, 45.375),
        Crcl(425.415, 311.193, 22.318),
        Crcl(750.765, 214.804, 13.179),
        Crcl(882.142, 744.115, 10.000),
        Crcl(617.786, 100.604, 14.881),
        Crcl(931.542, 889.577, 10.000),
        Crcl(130.672, 408.849, 21.764),
        Crcl(501.075, 76.276, 10.990),
        Crcl(215.813, 403.321, 10.000),
        Crcl(840.505, 866.917, 18.806),
        Crcl(428.448, 603.494, 22.554),
        Crcl(230.776, 203.860, 10.251),
        Crcl(445.333, 97.155, 23.415),
        Crcl(141.450, 88.893, 10.000),
        Crcl(207.146, 271.974, 10.000),
        Crcl(24.288, 921.148, 42.192),
        Crcl(133.029, 225.516, 10.000),
        Crcl(497.557, 372.346, 24.017),
        Crcl(481.434, 795.956, 10.000),
        Crcl(619.386, 914.703, 22.088),
        Crcl(300.150, 350.197, 10.000),
        Crcl(407.379, 842.190, 16.041),
        Crcl(524.098, 855.856, 28.473),
        Crcl(38.614, 165.989, 48.026),
        Crcl(937.676, 220.539, 27.316),
        Crcl(808.197, 341.519, 28.258),
        Crcl(41.972, 19.268, 38.267),
        Crcl(982.839, 723.114, 18.542),
        Crcl(110.408, 541.015, 25.774),
        Crcl(86.307, 475.988, 19.622),
        Crcl(817.511, 596.163, 14.037),
        Crcl(260.266, 453.062, 18.887),
        Crcl(681.982, 513.137, 29.456),
        Crcl(364.337, 916.362, 37.885),
        Crcl(235.965, 962.589, 41.079),
        Crcl(535.098, 927.441, 42.038),
        Crcl(597.701, 671.891, 27.222),
        Crcl(294.936, 660.276, 10.069),
        Crcl(133.026, 964.656, 10.000),
        Crcl(963.374, 843.267, 10.000),
        Crcl(901.287, 59.783, 15.987),
        Crcl(681.805, 454.211, 10.000),
        Crcl(989.266, 474.891, 48.065),
        Crcl(610.475, 363.668, 10.000),
        Crcl(468.345, 177.506, 10.000),
        Crcl(393.402, 123.611, 10.000),
        Crcl(598.171, 601.501, 13.401),
        Crcl(280.158, 871.024, 23.371),
        Crcl(270.735, 79.392, 29.621),
        Crcl(392.626, 272.549, 27.445),
        Crcl(666.703, 290.516, 10.000),
        Crcl(188.990, 549.398, 10.000),
        Crcl(33.032, 630.426, 30.510),
        Crcl(799.640, 114.212, 44.562),
        Crcl(169.183, 907.691, 24.468),
        Crcl(109.149, 23.171, 10.000),
        Crcl(711.953, 8.916, 35.687),
        Crcl(412.974, 792.032, 30.165),
        Crcl(2.574, 506.544, 15.884),
        Crcl(514.174, 592.828, 35.498),
        Crcl(360.197, 632.218, 12.876),
        Crcl(588.225, 723.994, 14.771),
        Crcl(314.893, 616.314, 10.000),
        Crcl(88.102, 260.327, 18.530),
        Crcl(850.517, 643.178, 42.011),
        Crcl(210.728, 505.321, 10.000),
        Crcl(928.694, 555.697, 10.000),
        Crcl(865.258, 991.996, 35.994),
        Crcl(188.112, 839.857, 43.885),
        Crcl(888.442, 499.627, 15.891),
        Crcl(619.787, 798.740, 10.000)
    };
    tests.push_back(Test(circles));
}

void randomTest100v3() {
    vector <Crcl> circles = {
        Crcl(126.683, 841.774, 223.694),
        Crcl(417.489, 510.801, 16.424),
        Crcl(913.654, 335.610, 325.829),
        Crcl(894.866, 946.332, 77.301),
        Crcl(111.423, 414.282, 152.850),
        Crcl(824.468, 712.819, 59.637),
        Crcl(570.679, 657.856, 105.004),
        Crcl(357.297, 200.330, 129.008),
        Crcl(397.095, 581.228, 38.730),
        Crcl(93.892, 33.056, 2.259),
        Crcl(461.073, 383.436, 42.185),
        Crcl(24.259, 14.529, 67.233),
        Crcl(485.720, 927.547, 144.226),
        Crcl(444.680, 640.376, 18.287),
        Crcl(479.302, 1.375, 15.097),
        Crcl(158.841, 112.054, 5.305),
        Crcl(958.498, 702.271, 8.121),
        Crcl(646.994, 965.234, 17.091),
        Crcl(474.277, 478.045, 3.121),
        Crcl(866.093, 808.144, 28.767),
        Crcl(134.764, 158.222, 8.529),
        Crcl(700.684, 969.474, 27.949),
        Crcl(733.984, 18.875, 9.367),
        Crcl(560.070, 490.420, 29.487),
        Crcl(138.458, 86.706, 26.572),
        Crcl(371.522, 368.809, 16.795),
        Crcl(722.968, 616.835, 5.118),
        Crcl(289.869, 512.687, 6.120),
        Crcl(302.127, 372.554, 40.663),
        Crcl(134.788, 36.985, 8.800),
        Crcl(50.313, 135.836, 41.841),
        Crcl(585.097, 167.617, 1.000),
        Crcl(406.273, 712.720, 46.658),
        Crcl(702.660, 830.583, 52.836),
        Crcl(534.378, 39.107, 13.022),
        Crcl(200.925, 1.368, 11.210),
        Crcl(588.726, 135.552, 26.540),
        Crcl(612.482, 38.886, 14.662),
        Crcl(502.651, 61.696, 8.702),
        Crcl(483.765, 454.135, 22.410),
        Crcl(200.534, 68.440, 13.501),
        Crcl(945.800, 784.507, 33.013),
        Crcl(632.408, 79.163, 6.351),
        Crcl(784.791, 653.484, 4.706),
        Crcl(372.803, 500.298, 17.478),
        Crcl(982.099, 709.046, 3.449),
        Crcl(117.469, 165.421, 10.150),
        Crcl(761.112, 955.411, 28.636),
        Crcl(319.842, 441.141, 30.161),
        Crcl(622.358, 801.745, 25.103),
        Crcl(702.793, 913.882, 4.614),
        Crcl(234.838, 574.633, 19.414),
        Crcl(505.836, 150.540, 4.364),
        Crcl(531.630, 418.300, 24.197),
        Crcl(17.173, 261.958, 1.000),
        Crcl(261.865, 295.713, 1.000),
        Crcl(492.983, 240.184, 7.928),
        Crcl(8.299, 249.570, 1.000),
        Crcl(300.381, 559.435, 9.889),
        Crcl(997.287, 813.459, 20.003),
        Crcl(952.256, 725.193, 11.115),
        Crcl(441.832, 784.985, 1.126),
        Crcl(885.807, 835.010, 4.071),
        Crcl(408.141, 446.936, 1.000),
        Crcl(483.030, 37.007, 16.875),
        Crcl(51.823, 241.221, 7.896),
        Crcl(284.279, 586.632, 4.376),
        Crcl(316.413, 1.373, 56.922),
        Crcl(141.839, 217.924, 30.140),
        Crcl(528.017, 315.748, 19.836),
        Crcl(1.750, 126.759, 3.791),
        Crcl(148.520, 126.035, 11.691),
        Crcl(312.563, 611.902, 5.944),
        Crcl(492.478, 84.923, 11.452),
        Crcl(626.847, 64.005, 2.250),
        Crcl(76.248, 215.291, 25.367),
        Crcl(691.816, 699.647, 14.350),
        Crcl(378.780, 464.862, 7.615),
        Crcl(32.093, 611.808, 10.619),
        Crcl(200.171, 582.788, 14.853),
        Crcl(884.116, 845.608, 4.710),
        Crcl(348.939, 477.002, 13.428),
        Crcl(673.066, 9.661, 3.678),
        Crcl(90.847, 56.875, 9.745),
        Crcl(517.652, 452.984, 7.650),
        Crcl(630.699, 562.502, 3.872),
        Crcl(910.417, 852.528, 16.679),
        Crcl(885.707, 859.263, 4.417),
        Crcl(462.039, 540.391, 17.078),
        Crcl(733.382, 619.781, 5.291),
        Crcl(549.874, 185.312, 30.678),
        Crcl(421.995, 32.673, 40.886),
        Crcl(514.553, 288.849, 9.648),
        Crcl(488.798, 273.293, 12.604),
        Crcl(983.188, 856.788, 1.589),
        Crcl(749.600, 647.861, 12.456),
        Crcl(980.377, 733.276, 13.255),
        Crcl(688.523, 898.900, 10.899),
        Crcl(786.996, 804.814, 4.172),
        Crcl(239.181, 628.968, 9.749)
    };
    tests.push_back(Test(circles));
}

void perfectGrid() {
    vector <Crcl> circles = {
        Crcl(0.000, 0.000, 50.000),
        Crcl(0.000, 111.000, 50.000),
        Crcl(0.000, 222.000, 50.000),
        Crcl(0.000, 333.000, 50.000),
        Crcl(0.000, 444.000, 50.000),
        Crcl(0.000, 555.000, 50.000),
        Crcl(0.000, 666.000, 50.000),
        Crcl(0.000, 777.000, 50.000),
        Crcl(0.000, 888.000, 50.000),
        Crcl(0.000, 999.000, 50.000),
        Crcl(111.000, 0.000, 50.000),
        Crcl(111.000, 111.000, 50.000),
        Crcl(111.000, 222.000, 50.000),
        Crcl(111.000, 333.000, 50.000),
        Crcl(111.000, 444.000, 50.000),
        Crcl(111.000, 555.000, 50.000),
        Crcl(111.000, 666.000, 50.000),
        Crcl(111.000, 777.000, 50.000),
        Crcl(111.000, 888.000, 50.000),
        Crcl(111.000, 999.000, 50.000),
        Crcl(222.000, 0.000, 50.000),
        Crcl(222.000, 111.000, 50.000),
        Crcl(222.000, 222.000, 50.000),
        Crcl(222.000, 333.000, 50.000),
        Crcl(222.000, 444.000, 50.000),
        Crcl(222.000, 555.000, 50.000),
        Crcl(222.000, 666.000, 50.000),
        Crcl(222.000, 777.000, 50.000),
        Crcl(222.000, 888.000, 50.000),
        Crcl(222.000, 999.000, 50.000),
        Crcl(333.000, 0.000, 50.000),
        Crcl(333.000, 111.000, 50.000),
        Crcl(333.000, 222.000, 50.000),
        Crcl(333.000, 333.000, 50.000),
        Crcl(333.000, 444.000, 50.000),
        Crcl(333.000, 555.000, 50.000),
        Crcl(333.000, 666.000, 50.000),
        Crcl(333.000, 777.000, 50.000),
        Crcl(333.000, 888.000, 50.000),
        Crcl(333.000, 999.000, 50.000),
        Crcl(444.000, 0.000, 50.000),
        Crcl(444.000, 111.000, 50.000),
        Crcl(444.000, 222.000, 50.000),
        Crcl(444.000, 333.000, 50.000),
        Crcl(444.000, 444.000, 50.000),
        Crcl(444.000, 555.000, 50.000),
        Crcl(444.000, 666.000, 50.000),
        Crcl(444.000, 777.000, 50.000),
        Crcl(444.000, 888.000, 50.000),
        Crcl(444.000, 999.000, 50.000),
        Crcl(555.000, 0.000, 50.000),
        Crcl(555.000, 111.000, 50.000),
        Crcl(555.000, 222.000, 50.000),
        Crcl(555.000, 333.000, 50.000),
        Crcl(555.000, 444.000, 50.000),
        Crcl(555.000, 555.000, 50.000),
        Crcl(555.000, 666.000, 50.000),
        Crcl(555.000, 777.000, 50.000),
        Crcl(555.000, 888.000, 50.000),
        Crcl(555.000, 999.000, 50.000),
        Crcl(666.000, 0.000, 50.000),
        Crcl(666.000, 111.000, 50.000),
        Crcl(666.000, 222.000, 50.000),
        Crcl(666.000, 333.000, 50.000),
        Crcl(666.000, 444.000, 50.000),
        Crcl(666.000, 555.000, 50.000),
        Crcl(666.000, 666.000, 50.000),
        Crcl(666.000, 777.000, 50.000),
        Crcl(666.000, 888.000, 50.000),
        Crcl(666.000, 999.000, 50.000),
        Crcl(777.000, 0.000, 50.000),
        Crcl(777.000, 111.000, 50.000),
        Crcl(777.000, 222.000, 50.000),
        Crcl(777.000, 333.000, 50.000),
        Crcl(777.000, 444.000, 50.000),
        Crcl(777.000, 555.000, 50.000),
        Crcl(777.000, 666.000, 50.000),
        Crcl(777.000, 777.000, 50.000),
        Crcl(777.000, 888.000, 50.000),
        Crcl(777.000, 999.000, 50.000),
        Crcl(888.000, 0.000, 50.000),
        Crcl(888.000, 111.000, 50.000),
        Crcl(888.000, 222.000, 50.000),
        Crcl(888.000, 333.000, 50.000),
        Crcl(888.000, 444.000, 50.000),
        Crcl(888.000, 555.000, 50.000),
        Crcl(888.000, 666.000, 50.000),
        Crcl(888.000, 777.000, 50.000),
        Crcl(888.000, 888.000, 50.000),
        Crcl(888.000, 999.000, 50.000),
        Crcl(999.000, 0.000, 50.000),
        Crcl(999.000, 111.000, 50.000),
        Crcl(999.000, 222.000, 50.000),
        Crcl(999.000, 333.000, 50.000),
        Crcl(999.000, 444.000, 50.000),
        Crcl(999.000, 555.000, 50.000),
        Crcl(999.000, 666.000, 50.000),
        Crcl(999.000, 777.000, 50.000),
        Crcl(999.000, 888.000, 50.000),
        Crcl(999.000, 999.000, 50.000)
    };
    tests.push_back(Test(circles));
}

void flawedGrid() {
    vector <Crcl> circles = {
        Crcl(0.000, 0.000, 49.965),
        Crcl(0.000, 111.000, 49.969),
        Crcl(0.000, 222.000, 50.028),
        Crcl(0.000, 333.000, 50.053),
        Crcl(0.000, 444.000, 49.952),
        Crcl(0.000, 555.000, 50.053),
        Crcl(0.000, 666.000, 49.980),
        Crcl(0.000, 777.000, 50.041),
        Crcl(0.000, 888.000, 50.045),
        Crcl(0.000, 999.000, 50.071),
        Crcl(111.000, 0.000, 49.968),
        Crcl(111.000, 111.000, 49.968),
        Crcl(111.000, 222.000, 50.024),
        Crcl(111.000, 333.000, 50.025),
        Crcl(111.000, 444.000, 49.924),
        Crcl(111.000, 555.000, 49.929),
        Crcl(111.000, 666.000, 49.916),
        Crcl(111.000, 777.000, 50.045),
        Crcl(111.000, 888.000, 50.043),
        Crcl(111.000, 999.000, 50.016),
        Crcl(222.000, 0.000, 49.967),
        Crcl(222.000, 111.000, 50.055),
        Crcl(222.000, 222.000, 49.905),
        Crcl(222.000, 333.000, 49.901),
        Crcl(222.000, 444.000, 50.032),
        Crcl(222.000, 555.000, 50.008),
        Crcl(222.000, 666.000, 49.902),
        Crcl(222.000, 777.000, 49.958),
        Crcl(222.000, 888.000, 50.077),
        Crcl(222.000, 999.000, 50.037),
        Crcl(333.000, 0.000, 49.934),
        Crcl(333.000, 111.000, 50.099),
        Crcl(333.000, 222.000, 50.089),
        Crcl(333.000, 333.000, 50.053),
        Crcl(333.000, 444.000, 50.072),
        Crcl(333.000, 555.000, 50.069),
        Crcl(333.000, 666.000, 49.901),
        Crcl(333.000, 777.000, 50.007),
        Crcl(333.000, 888.000, 50.037),
        Crcl(333.000, 999.000, 50.058),
        Crcl(444.000, 0.000, 50.070),
        Crcl(444.000, 111.000, 49.925),
        Crcl(444.000, 222.000, 50.079),
        Crcl(444.000, 333.000, 50.067),
        Crcl(444.000, 444.000, 49.973),
        Crcl(444.000, 555.000, 50.005),
        Crcl(444.000, 666.000, 49.978),
        Crcl(444.000, 777.000, 49.908),
        Crcl(444.000, 888.000, 50.079),
        Crcl(444.000, 999.000, 50.089),
        Crcl(555.000, 0.000, 49.941),
        Crcl(555.000, 111.000, 50.035),
        Crcl(555.000, 222.000, 49.948),
        Crcl(555.000, 333.000, 49.994),
        Crcl(555.000, 444.000, 50.040),
        Crcl(555.000, 555.000, 50.008),
        Crcl(555.000, 666.000, 50.082),
        Crcl(555.000, 777.000, 49.958),
        Crcl(555.000, 888.000, 49.940),
        Crcl(555.000, 999.000, 49.903),
        Crcl(666.000, 0.000, 50.066),
        Crcl(666.000, 111.000, 49.967),
        Crcl(666.000, 222.000, 49.916),
        Crcl(666.000, 333.000, 49.941),
        Crcl(666.000, 444.000, 50.049),
        Crcl(666.000, 555.000, 49.959),
        Crcl(666.000, 666.000, 50.036),
        Crcl(666.000, 777.000, 50.041),
        Crcl(666.000, 888.000, 49.940),
        Crcl(666.000, 999.000, 50.059),
        Crcl(777.000, 0.000, 50.029),
        Crcl(777.000, 111.000, 50.062),
        Crcl(777.000, 222.000, 50.054),
        Crcl(777.000, 333.000, 50.015),
        Crcl(777.000, 444.000, 50.090),
        Crcl(777.000, 555.000, 50.088),
        Crcl(777.000, 666.000, 49.962),
        Crcl(777.000, 777.000, 50.060),
        Crcl(777.000, 888.000, 49.936),
        Crcl(777.000, 999.000, 49.923),
        Crcl(888.000, 0.000, 49.987),
        Crcl(888.000, 111.000, 50.017),
        Crcl(888.000, 222.000, 49.925),
        Crcl(888.000, 333.000, 50.095),
        Crcl(888.000, 444.000, 49.922),
        Crcl(888.000, 555.000, 50.003),
        Crcl(888.000, 666.000, 49.986),
        Crcl(888.000, 777.000, 50.077),
        Crcl(888.000, 888.000, 50.000),
        Crcl(888.000, 999.000, 50.034),
        Crcl(999.000, 0.000, 50.013),
        Crcl(999.000, 111.000, 50.066),
        Crcl(999.000, 222.000, 50.022),
        Crcl(999.000, 333.000, 50.099),
        Crcl(999.000, 444.000, 49.960),
        Crcl(999.000, 555.000, 49.902),
        Crcl(999.000, 666.000, 50.093),
        Crcl(999.000, 777.000, 50.002),
        Crcl(999.000, 888.000, 50.016),
        Crcl(999.000, 999.000, 50.053)
    };
    tests.push_back(Test(circles));
}

void towardsEdges() {
    vector <Crcl> circles = {
        Crcl(964.354, 621.916, 56.641),
        Crcl(59.915, 559.710, 36.357),
        Crcl(527.787, 27.566, 73.861),
        Crcl(981.864, 60.065, 43.380),
        Crcl(7.880, 190.283, 3.326),
        Crcl(54.482, 264.786, 50.912),
        Crcl(52.216, 924.986, 99.699),
        Crcl(915.823, 360.949, 20.388),
        Crcl(52.824, 713.805, 31.224),
        Crcl(171.587, 42.367, 4.204),
        Crcl(946.925, 805.670, 67.609),
        Crcl(637.071, 917.717, 72.457),
        Crcl(991.257, 207.692, 96.481),
        Crcl(47.020, 94.812, 42.055),
        Crcl(807.149, 916.738, 64.055),
        Crcl(259.867, 52.285, 45.254),
        Crcl(390.755, 947.953, 32.914),
        Crcl(798.242, 8.474, 59.402),
        Crcl(917.339, 988.677, 9.772),
        Crcl(407.361, 6.427, 10.308),
        Crcl(944.022, 900.748, 1.065),
        Crcl(69.684, 671.644, 12.772),
        Crcl(375.638, 48.809, 21.382),
        Crcl(13.636, 754.911, 1.000),
        Crcl(908.769, 917.487, 1.475),
        Crcl(890.241, 39.037, 8.983),
        Crcl(993.232, 913.227, 23.678),
        Crcl(866.256, 985.679, 18.371),
        Crcl(92.245, 655.998, 8.694),
        Crcl(16.067, 435.551, 89.169),
        Crcl(464.310, 907.837, 32.999),
        Crcl(925.033, 484.178, 67.554),
        Crcl(316.960, 37.086, 4.356),
        Crcl(71.357, 193.926, 3.263),
        Crcl(316.765, 98.275, 19.282),
        Crcl(224.801, 951.570, 29.995),
        Crcl(632.071, 98.753, 26.272),
        Crcl(270.020, 999.614, 14.298),
        Crcl(90.472, 351.932, 21.588),
        Crcl(847.487, 84.571, 16.296),
        Crcl(99.395, 146.003, 21.353),
        Crcl(410.029, 75.946, 16.156),
        Crcl(22.406, 162.502, 15.559),
        Crcl(908.592, 967.523, 3.648),
        Crcl(197.990, 25.159, 9.162),
        Crcl(284.471, 937.751, 16.891),
        Crcl(757.633, 84.286, 2.892),
        Crcl(765.183, 998.895, 3.675),
        Crcl(444.421, 943.565, 1.148),
        Crcl(938.333, 707.743, 11.337),
        Crcl(925.178, 55.143, 9.961),
        Crcl(131.161, 68.664, 39.839),
        Crcl(513.340, 960.945, 12.722),
        Crcl(947.710, 982.556, 20.729),
        Crcl(980.521, 383.843, 11.788),
        Crcl(674.606, 41.405, 37.083),
        Crcl(79.772, 25.844, 7.848),
        Crcl(61.975, 11.377, 14.031),
        Crcl(39.735, 190.921, 1.210),
        Crcl(991.141, 702.948, 1.000),
        Crcl(12.227, 791.433, 30.846),
        Crcl(427.410, 40.399, 5.693),
        Crcl(216.396, 95.695, 16.086),
        Crcl(723.858, 91.369, 12.503),
        Crcl(958.167, 716.072, 9.199),
        Crcl(75.923, 813.344, 11.547),
        Crcl(28.032, 15.963, 17.405),
        Crcl(464.754, 983.841, 24.495),
        Crcl(732.252, 962.091, 17.178),
        Crcl(882.048, 55.576, 9.131),
        Crcl(315.166, 925.441, 10.234),
        Crcl(904.624, 640.101, 5.602),
        Crcl(98.550, 780.262, 21.946),
        Crcl(444.561, 95.538, 21.247),
        Crcl(32.468, 630.425, 37.139),
        Crcl(5.858, 552.282, 9.744),
        Crcl(345.816, 59.225, 3.919),
        Crcl(182.973, 916.694, 1.586),
        Crcl(987.017, 420.800, 1.000),
        Crcl(81.499, 52.612, 10.373),
        Crcl(905.494, 86.198, 9.822),
        Crcl(57.029, 786.327, 4.569),
        Crcl(715.727, 942.961, 5.598),
        Crcl(626.784, 63.768, 6.112),
        Crcl(944.029, 1.424, 4.227),
        Crcl(55.675, 168.024, 10.973),
        Crcl(527.782, 924.284, 25.598),
        Crcl(941.688, 920.026, 2.410),
        Crcl(736.501, 3.481, 2.484),
        Crcl(935.620, 398.091, 16.262),
        Crcl(929.145, 910.269, 13.282),
        Crcl(71.444, 755.502, 11.177),
        Crcl(924.137, 29.323, 14.126),
        Crcl(900.042, 974.339, 2.983),
        Crcl(950.368, 696.083, 1.565),
        Crcl(967.701, 321.734, 1.000),
        Crcl(159.737, 996.673, 21.317),
        Crcl(290.439, 975.172, 10.569),
        Crcl(75.450, 652.945, 2.485),
        Crcl(93.860, 716.282, 5.795)
    };
    tests.push_back(Test(circles));
}

const int MAX = 101;
const long double EPS = 0.00000000000001;

struct Point {
    long double x, y;
    Point(long double x_ = 0.0, long double y_ = 0.0) : x(x_), y(y_) {}
};

struct Circle {
    Point center;
    long double radius;
};

int n;
Circle a[MAX];
vector <Point> candidates;
Point answer;

long double findDist(Point p1, Point p2) {
    return sqrtl((p2.x - p1.x) * (p2.x - p1.x) + (p2.y - p1.y) * (p2.y - p1.y));
}

Point pointOnLine(const Point& p1, const Point& p2, long double ratio) {
    return Point(p1.x + (p2.x - p1.x) * ratio, p1.y + (p2.y - p1.y) * ratio);
}

Point findClosest(const Point& p1, const Point& p2, const Point& target, long double offset) {
    long double left = 0.0, right = 1.0;
    for (int iter = 0; iter < 300; iter++) {
        long double m1 = left + (right - left) / 3.0;
        long double m2 = right - (right - left) / 3.0;
        long double d1 = fabs(findDist(target, pointOnLine(p1, p2, m1)) - offset);
        long double d2 = fabs(findDist(target, pointOnLine(p1, p2, m2)) - offset);
        d1 < d2 ? right = m2 : left = m1;
    }
    return pointOnLine(p1, p2, right);
}

void circleLine(const Circle& circle, const Point& p1, const Point& p2) {
    Point closest = findClosest(p1, p2, circle.center, 0.0);
    if (findDist(closest, circle.center) > circle.radius + EPS)
        return;
    Point cand1 = findClosest(closest, p1, circle.center, circle.radius);
    if (fabs(findDist(cand1, circle.center) - circle.radius) < EPS)
        candidates.push_back(cand1);
    Point cand2 = findClosest(closest, p2, circle.center, circle.radius);
    if (fabs(findDist(cand2, circle.center) - circle.radius) < EPS)
        candidates.push_back(cand2);
}

Point rotate(const Point& origin, const Point& point, long double angle) {
    long double s = sin(angle), c = cos(angle);
    Point trans(point.x - origin.x, point.y - origin.y);
    return Point(origin.x + trans.x * c - trans.y * s, origin.y + trans.x * s + trans.y * c);
}

void circleCircle(Circle circle1, Circle circle2) {
    long double dist = findDist(circle1.center, circle2.center);
    if (dist > circle1.radius + circle2.radius)
        return;
    if (fabs(dist - (circle1.radius + circle2.radius)) < EPS) {
        candidates.push_back(
            pointOnLine(circle1.center, circle2.center,
                        circle1.radius / (circle1.radius + circle2.radius))
        );
        return;
    }

    Point p = pointOnLine(circle1.center, circle2.center, circle1.radius / dist);
    long double angle = acos(
        (pow(circle1.radius, 2.0) + pow(dist, 2.0) - pow(circle2.radius, 2.0)) / (2.0 * circle1.radius * dist)
    );
    candidates.push_back(rotate(circle1.center, p, +angle));
    candidates.push_back(rotate(circle1.center, p, -angle));
}

bool eval(long double radius) {
    for (int i = 0; i < n; i++)
        a[i].radius += radius;

    candidates.clear();
    candidates.push_back(Point(0, 0));
    candidates.push_back(Point(0, 1000));
    candidates.push_back(Point(1000, 0));
    candidates.push_back(Point(1000, 1000));

    for (int i = 0; i < n; i++) {
        circleLine(a[i], Point(0, 0), Point(0, 1000));
        circleLine(a[i], Point(0, 0), Point(1000, 0));
        circleLine(a[i], Point(1000, 1000), Point(0, 1000));
        circleLine(a[i], Point(1000, 1000), Point(1000, 0));
    }

    for (int c1 = 0; c1 < n; c1++) {
        for (int c2 = c1 + 1; c2 < n; c2++) {
            circleCircle(a[c1], a[c2]);
        }
    }

//    fprintf(stderr, "  >> number of points to check: %d\n", (int)candidates.size());

    answer = Point(-1.0, -1.0);
    for (int i = 0; i < (int)candidates.size(); i++) {
        if (candidates[i].x < 0.0 || candidates[i].x > 1000.0) continue;
        if (candidates[i].y < 0.0 || candidates[i].y > 1000.0) continue;

        bool okay = true;
        for (int c = 0; c < n; c++) {
            if (findDist(candidates[i], a[c].center) < a[c].radius - EPS) {
                okay = false;
                break;
            }
        }
        if (okay) {
            answer = candidates[i];
            break;
        }
    }

    for (int i = 0; i < n; i++)
        a[i].radius -= radius;
    return answer.x >= 0.0 && answer.y >= 0.0;
}

long double solve() {
    long double left = 0.0, right = 2000.0;
    for (int iter = 0; iter < 100; iter++) {
        long double mid = (left + right) / 2.0;
        eval(mid) ? left = mid : right = mid;
    }
    eval(left - EPS);
    return left;
}

void validate() {
    if (n < 2 || n > 100) {
        fprintf(stderr, "ERROR: N is invalid (%d)\n", n);
        exit(-1);
    }
    for (int i = 0; i < n; i++) {
        if (a[i].radius < 1 || a[i].radius > 1414) {
            fprintf(stderr, "ERROR: Invalid radius (%lf)\n", a[i].radius);
            exit(-1);
        }
        if (a[i].center.x < 0.0 || a[i].center.x > 1000.0) {
            fprintf(stderr, "ERROR: Invalid X (%lf)\n", a[i].center.x);
            exit(-1);
        }
        if (a[i].center.y < 0.0 || a[i].center.y > 1000.0) {
            fprintf(stderr, "ERROR: Invalid Y (%lf)\n", a[i].center.y);
            exit(-1);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int c = i + 1; c < n; c++) {
            if (findDist(a[i].center, a[c].center) < a[i].radius + a[c].radius) {
                fprintf(stderr, "Circles %d and %d overlap!\n", i, c);
                exit(-1);
            }
        }
    }
}

string remTrail(long double num) {
    char buff[32];
    sprintf(buff, "%.9Lf", num);
    int idx = (int)strlen(buff) - 1;
    while (buff[idx] == '0') {
        buff[idx--] = '\0';
    }
    if (buff[idx] == '.')
        buff[idx--] = '\0';
    return string(buff);
}

void printTests() {
    for (int t = 0; t < (int)tests.size(); t++) {
        fprintf(stderr, "Printing testcase %d...\n", t);

        n = (int)tests[t].circles.size();
        for (int i = 0; i < n; i++) {
            a[i].radius = tests[t].circles[i].r;
            a[i].center = Point(tests[t].circles[i].x, tests[t].circles[i].y);
        }
        validate();

        char inpFile[32], solFile[32];
        sprintf(inpFile, "Incinerator.%02d.in", t);
        sprintf(solFile, "Incinerator.%02d.sol", t);

        FILE* inp = fopen(inpFile, "wt");
        fprintf(inp, "%d\n", n);
        for (int i = 0; i < n; i++)
            fprintf(inp, "%s %s %s\n",
                remTrail(a[i].center.x).c_str(),
                remTrail(a[i].center.y).c_str(),
                remTrail(a[i].radius).c_str()
            );
        fclose(inp);

        unsigned sTime = clock();
        long double ans = solve();
        fprintf(stderr, "  >> answer: %.12Lf (%.6Lf, %.6Lf)\n", ans, answer.x, answer.y);
        fprintf(stderr, "  >> execution time: %.3lfs\n", (double)(clock() - sTime) / CLOCKS_PER_SEC);

        FILE* sol = fopen(solFile, "wt");
        fprintf(sol, "%.12Lf\n", ans);
        fclose(sol);
    }
}

int main(void) {
    sampleInput();

    testTwo1();
    testTwo2();
    testTwo3();
    testTwo4();
    testTwo5();
    testTwo6();

    handTest1();
    handTest2();
    handTest3();
    handTest4();
    handTest5();
    handTest6();

    randomTest50();
    randomTest75();
    randomTest100v1();
    randomTest100v2();
    randomTest100v3();

    perfectGrid();
    flawedGrid();
    towardsEdges();

    printTests();

    return 0;
}
